diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
index 0bf60b445..0b818cb64 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
@@ -39,16 +39,15 @@ import static net.minecraft.core.block.piston.PistonCommon.*;
 public class BlockLogicPistonBase extends BlockLogic {
 	public final byte typeId;
 
-    final byte pushLimit, crushLimit;
+    final byte pushLimit, pullLimit, crushLimit;
     final @Nullable EnumDropCause crushAction;
-    final boolean canPull;
     final double flingStrength;
 
     public BlockLogicPistonBase(
         @NotNull Block<? extends BlockLogicPistonBase> block, 
         byte typeId,
-        byte pushLimit, byte crushLimit,
-        @Nullable EnumDropCause crushAction, boolean canPull, double flingStrength
+        int pushLimit, int pullLimit, int crushLimit,
+        @Nullable EnumDropCause crushAction, double flingStrength
     ) {
         super(block, Materials.PISTON);
         block.withHardness(0.5F);
@@ -57,10 +56,10 @@ public class BlockLogicPistonBase extends BlockLogic {
         assert typeId >= 0 && typeId < 3;
         assert pushLimit <= 64;
 
-        this.pushLimit = pushLimit;
-        this.crushLimit = crushLimit;
+        this.pushLimit = (byte)pushLimit;
+        this.pullLimit = (byte)pullLimit;
+        this.crushLimit = (byte)crushLimit;
         this.crushAction = crushAction;
-        this.canPull = canPull;
         this.flingStrength = flingStrength;
     }
 
@@ -77,15 +76,20 @@ public class BlockLogicPistonBase extends BlockLogic {
         final boolean powered = hasNeighborSignal(world, tilePos, Direction.fromId(DIRECTION.get(data)));
         final boolean extended = IS_EXTENDED.bool(data);
         final boolean detached = IS_DETACHED.bool(data);
+        final var dir = Direction.fromId(DIRECTION.get(data));
         
         if (powered == extended) return false;
 
         int event = (!detached) ? EVENT_EXTEND : EVENT_DETACH_EXTEND;
         event |= (powered) ? 0 : 1;
 
-        final var lineInfo = (powered && !detached)
-            ? testLine(world, tilePos, Direction.fromId(DIRECTION.get(data)))
-            : 0;
+        final int lineInfo;
+        if (detached) {
+            lineInfo = 0;
+        } else {
+            lineInfo = (powered) ? testPushLine(world, tilePos, dir) : testPullLine(world, tilePos, dir);
+        }
+
         assert (lineInfo & ~0xFF) == 0;
 
         if (LINE_OBSTRUCTED.bool(lineInfo)) return false;
@@ -121,7 +125,7 @@ public class BlockLogicPistonBase extends BlockLogic {
                     // serverside / singleplayer should have already fixed this 
                     fixLegacyBaseData(world, tilePos);
                 }
-                this.retract(world, tilePos, data);
+                this.retract(world, tilePos, data, eventData);
             }
             break;
         }
@@ -218,30 +222,46 @@ public class BlockLogicPistonBase extends BlockLogic {
      * if {@code LINE_OBSTRUCTED.bool(n)}, line can't be pushed; <br>
      * if {@code CRUSH_EOL.bool(n)}, end of line should be crushed; <br>
      */
-    public int testLine(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Direction dir) {
+    public int testPushLine(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Direction dir) {
         final var pos = new TilePos(tilePos).add(dir);
-        final int maxY = world.getHeightBlocks();
-        final int pushLimit = LINE_LENGTH.get(this.pushLimit);
-
-        if (pushLimit == 0) return 0;
-        for (int i = 0; i <= pushLimit; i++, pos.add(dir)) {
-            final int nope = LINE_OBSTRUCTED.mask | i;
+        final int limit = LINE_LENGTH.get(this.pushLimit);
 
-            if (pos.y < 0 || pos.y >= maxY) return nope;
-
-            switch (Movability.test(world, pos)) {
+        if (limit == 0) return 0;
+        for (int i = 0; i <= limit; i++, pos.add(dir)) {
+            switch (Movability.test(world, pos, dir)) {
             case BREAKS: 
                 return i;
-            case MOVES:
-                if (i >= pushLimit) return nope;
+            case PUSHES, PULLS:
+                if (i >= limit) return LINE_OBSTRUCTED.mask | i;
                 continue;
             case CRUSHES:
-                if (this.crushAction == null) return nope; 
-                if (i == 0) return nope;
-                if (i > this.crushLimit) return nope;
+                if (this.crushAction == null) return LINE_OBSTRUCTED.mask | i; 
+                if (i == 0) return LINE_OBSTRUCTED.mask | i;
+                if (i > this.crushLimit) return LINE_OBSTRUCTED.mask | i;
                 return CRUSH_EOL.mask | i - 1;
             case OBSTRUCTED:
-                return nope;
+                return LINE_OBSTRUCTED.mask | i;
+            }
+            assert false : "unreachable";
+        }
+        assert false : "unreachable"; return 0;
+    }
+
+    public int testPullLine(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Direction dir) {
+        final var pos =  new TilePos(tilePos).add(dir).add(dir);
+        final int limit = LINE_LENGTH.get(this.pullLimit);
+
+        if (limit == 0) return 0;
+        for (int i = 0; i <= limit; i++, pos.add(dir)) {
+            switch (Movability.test(world, pos, dir)) {
+            case PULLS:
+                if (i >= limit) return 0;
+                continue;
+            case PUSHES:
+                if (i >= limit) return 0;
+                return i + 1;
+            case BREAKS, CRUSHES, OBSTRUCTED:
+                return i;
             }
             assert false : "unreachable";
         }
@@ -249,18 +269,26 @@ public class BlockLogicPistonBase extends BlockLogic {
     }
 
     public static enum Movability {
-        OBSTRUCTED, MOVES, BREAKS, CRUSHES;
+        OBSTRUCTED, PUSHES, PULLS, BREAKS, CRUSHES;
 
-        public static @NotNull Movability test(@NotNull World world, @NotNull TilePosc tilePos) {
+        public static @NotNull Movability test(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Direction direction) {
+            if (tilePos.y() < 0 || tilePos.y() >= world.getHeightBlocks()) return OBSTRUCTED;
+            
             final var block = world.getBlockType(tilePos);
-            if (block == Blocks.AIR) return BREAKS;
             if (block.hasTag(BlockTags.PISTON_CRUSHING)) return CRUSHES;
-            switch (block.getPistonPushReaction(world, tilePos)) {
-                case Material.PISTON_DESTROY_ON_PUSH: return BREAKS;
-                case Material.PISTON_CANT_PUSH: return OBSTRUCTED;
-            }
-            if (block.getImmovable() || block.getHardness() == -1F) return OBSTRUCTED;
-            return MOVES;
+
+            return switch (block.getPistonPushReaction(world, tilePos)) {
+                case Material.PISTON_DESTROY_ON_PUSH -> BREAKS;
+                case Material.PISTON_CANT_PUSH -> OBSTRUCTED;
+                default -> {
+                    // hardcoded. I don't want premature abstraction until we do sticky blocks for real
+                    if (block != Blocks.PISTON_HEAD) yield PUSHES;
+                    final var data = world.getBlockData(tilePos);
+                    if (TYPE.get(data) != TYPE_STICKY) yield PUSHES;
+                    if (DIRECTION.get(data) != direction.id) yield PUSHES;
+                    yield PULLS;
+                }
+            };
         }
     }
 
@@ -276,13 +304,15 @@ public class BlockLogicPistonBase extends BlockLogic {
     //     └─ ?pull
     // 
 
-    private boolean extend(@NotNull World world, @NotNull TilePosc tilePos, int data, int lineInfo) {
+    private boolean extend(@NotNull World world, @NotNull TilePosc basePos, int data, int lineInfo) {
         data = validateBaseData(data, this);
         final var dir = Direction.fromId(DIRECTION.get(data));
-        final var headPos = new TilePos(tilePos).add(dir);
-
-        world.setBlockData(tilePos, IS_EXTENDED.set(data, 1));
-        world.markBlockNeedsUpdate(tilePos);
+        
+        final TilePos query1 = new TilePos(), query2 = new TilePos();
+        final TilePosc headPos = new TilePos(basePos).add(dir);
+        
+        world.setBlockData(basePos, IS_EXTENDED.set(data, 1));
+        world.markBlockNeedsUpdate(basePos);
 
         final boolean canFling = !Double.isNaN(this.flingStrength);
         if (canFling) flingEntity(world, headPos, dir);
@@ -291,13 +321,20 @@ public class BlockLogicPistonBase extends BlockLogic {
         final boolean shouldCrush = CRUSH_EOL.bool(lineInfo);
         final boolean shouldFling = !shouldCrush && canFling && len == 1;
 
-        @Nullable MovingLine line = null;
+        final @Nullable MovingLine line;
         if (shouldFling) {
-            flingBlock(world, headPos, dir);
+            this.flingBlock(world, headPos, dir);
+            line = null;
         } else {
             final var tailAction = (shouldCrush) ? this.crushAction : EnumDropCause.WORLD;
-            breakTail(tailAction, world, headPos, dir, len);
-            line = push(world, headPos, dir, len);
+            this.breakTail(tailAction, world, headPos, dir, len);
+            line = (len > 0) ? new MovingLine(len, world, dir, headPos, true) : null;
+        }
+
+        if (line != null) {
+            line.init(query1);
+            line.computeSignalMask();
+            line.move(query1);
         }
 
         final var headData = DIRECTION.set(0, dir.id) | TYPE.getNoShift(data);
@@ -308,64 +345,13 @@ public class BlockLogicPistonBase extends BlockLogic {
         world.setBlockTypeDataEntity(headPos, Blocks.PISTON_MOVING, headData, headMoving);
 
         // extension updates base immediately, and head 3 ticks after 
-        world.notifyBlocksOfNeighborChange(tilePos, this.block);
+        world.notifyBlocksOfNeighborChange(basePos, this.block);
 
-        if (line != null) {
-            final var tar = new TilePos();
-            final var src = new TilePos();
-
-            for (int i = len;  i > 0; ) {
-                i--;
-                line.getTargetPos(i, tar);
-                line.getSourcePos(i, src);
-                line.blocks[i].onMoved(world, src, tar, line.movingBlocks[i], i, line);
-            }
-        }
+        if (line != null) line.notify(query1, query2);
 
         return true;
     }
 
-    private static @Nullable MovingLine push(@NotNull World world, @NotNull TilePosc headPos, @NotNull Direction dir, int len) {
-        if (len <= 0) return null;
-        final TilePos pos1 = new TilePos(), pos2 = new TilePos();
-
-        final var line = new MovingLine(len, world, dir, headPos, true);
-
-        /* block type,data,entity lookup */ {
-            final var queryPos = pos1.set(headPos);
-            for (int i = 0;  i < len;  i++, queryPos.add(dir)) {
-                line.blocks[i] = world.getBlockType(queryPos);
-                line.data[i] = (byte)world.getBlockData(queryPos);
-                line.entities[i] = world.getTileEntity(queryPos);
-
-                // We DON'T handle moving piston, as it is ruled out in movability test
-                assert line.blocks[i] != Blocks.PISTON_MOVING;
-                assert !(line.entities[i] instanceof TileEntityMovingPistonBlock);
-            }
-        }
-
-        line.computeConductMask();
-        line.computeSignalMask();
-        
-        /* move */ {
-            final var tar = dir.offsetScaled(pos1.set(headPos), len);
-            final var src = dir.offsetScaled(pos2.set(headPos), len - 1);
-
-            for (int i = len;  i > 0;  src.sub(dir), tar.sub(dir)) {
-                i--;
-                assert tar != headPos;
-
-                world.removeTileEntity(src);
-                world.setBlockTypeRaw(src, Blocks.AIR);
-
-                world.setBlockTypeDataEntity(tar, Blocks.PISTON_MOVING, line.data[i], line.createMoving(i));
-            }
-        }
-
-        return line;
-    }
-
-
     private void breakTail(
         @NotNull EnumDropCause cause, @NotNull World world, @NotNull TilePosc headPos,
         @NotNull Direction dir, int off
@@ -373,7 +359,7 @@ public class BlockLogicPistonBase extends BlockLogic {
         final var target = dir.offsetScaled(new TilePos(headPos), off);
 
         final var block = world.getBlockType(target);
-        if (block.id() > 0) {
+        if (block != Blocks.AIR) {
             world.playBlockEvent(null, target, LevelListener.EVENT_BLOCK_BREAK, block.id());
         }
 
@@ -391,6 +377,7 @@ public class BlockLogicPistonBase extends BlockLogic {
         // note that flingEntity is performed before flingBlock, therefore no need to 
         // check for flingBlock
         for (final var entity : entities) {
+            if (entity.noPhysics) continue;
             entity.fling(vx, vy, vz, 1f);
         }
     }
@@ -426,10 +413,16 @@ public class BlockLogicPistonBase extends BlockLogic {
         block.onFlung(world, headPos, blockMeta, flungBlock.carriedBlock);
     }
 
-    private void retract(@NotNull World world, @NotNull TilePosc tilePos, int data) {
+    private void retract(@NotNull World world, @NotNull TilePosc basePos, int data, int lineInfo) {
         data = validateBaseData(data, this);
         final var dir = Direction.fromId(DIRECTION.get(data));
-        final var headPos = new TilePos(tilePos).add(dir);
+
+        final TilePos query1 = new TilePos(), query2 = new TilePos();
+        final var headPos = new TilePos(basePos).add(dir);
+        final TilePosc sourcePos = query1.set(basePos).add(dir).add(dir, new TilePos());
+
+
+        final int len = LINE_LENGTH.get(lineInfo);
 
         if (world.getTileEntity(headPos) instanceof TileEntityMovingPistonBlock moving && !moving.isExtending) {
             moving.finalTick();
@@ -440,55 +433,23 @@ public class BlockLogicPistonBase extends BlockLogic {
         final var moving = new TileEntityMovingPistonBlock(
             MovingType.RETRACTING_PISTON,
             this.block, dir.id, null, dir);
-        world.setBlockTypeRaw(tilePos, Blocks.AIR);
-        world.setBlockTypeDataEntity(tilePos, Blocks.PISTON_MOVING, data, moving);
-
-        if (this.canPull) pull(world, headPos, dir);
+        world.setBlockTypeRaw(basePos, Blocks.AIR);
+        world.setBlockTypeDataEntity(basePos, Blocks.PISTON_MOVING, data, moving);
+
+        if (len > 0) {
+            final var line = new MovingLine(len, world, dir, sourcePos, false);
+            line.init(query1);
+            line.computeSignalMask();
+            line.move(query1);
+            line.notify(query1, query2);
+        }
 
         // logically, retraction should only update head immediately, and base 3 ticks after
         // but this emulates the old behavior
-        world.notifyBlocksOfNeighborChange(tilePos, this.block);
+        world.notifyBlocksOfNeighborChange(basePos, this.block);
         world.notifyBlocksOfNeighborChange(headPos, null);
     }
 
-    private static void pull(@NotNull World world, @NotNull TilePosc headPos, @NotNull Direction dir) {
-        final var tar = headPos;
-        final var src = new TilePos(tar).add(dir);
-
-        final var entity = world.getTileEntity(src);
-
-        if (entity instanceof TileEntityMovingPistonBlock moving) position_moving: {
-            if (moving.direction != dir) break position_moving;
-            if (!moving.isExtending) break position_moving;
-            assert world.getBlockType(src) == Blocks.PISTON_MOVING;
-
-            // 0t
-            moving.finalTick();
-            return;
-        }
-
-        if (Movability.test(world, src) != Movability.MOVES) {
-            world.removeTileEntity(tar);
-            world.setBlockType(tar, Blocks.AIR);
-            return;
-        }
-
-        final var block = world.getBlockType(src);
-        final var data = world.getBlockData(src);
-        world.removeTileEntity(src);
-
-        final var line = new MovingLine(1, world, dir, headPos, false);
-        line.blocks[0] = block;
-        line.data[0] = (byte)data;
-        line.entities[0] = entity;
-
-        world.setBlockTypeRaw(src, Blocks.AIR);
-        world.setBlockTypeDataEntity(tar, Blocks.PISTON_MOVING, data, line.createMoving(0));
-
-        block.onMoved(world, src, tar, line.movingBlocks[0], 0, line);
-        world.notifyBlocksOfNeighborChange(src, Blocks.AIR);
-    }
-
     // BlockLogic impl:
     // ====================
 
@@ -633,4 +594,16 @@ public class BlockLogicPistonBase extends BlockLogic {
         ctx.buf[0] = new ItemStack(this.block, 1, data);
         return ctx.buf;
     }
+
+    @Override
+    public @NotNull String getLanguageKey(int data) {
+        interface ctx {
+            String[] KEYMAP = {
+                BASE_BLOCK_MAP[TYPE_NORMAL].getKey() + ".detached",
+                BASE_BLOCK_MAP[TYPE_STICKY].getKey() + ".detached",
+                BASE_BLOCK_MAP[TYPE_STEEL].getKey() + ".detached",
+            }; 
+        }
+        return (IS_DETACHED.bool(data)) ? ctx.KEYMAP[this.typeId] : this.block.getKey();
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
index 4a3d1de91..e8f2f9aba 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
@@ -22,6 +22,7 @@ import java.util.List;
 
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
 public class BlockLogicPistonMoving extends BlockLogic {
@@ -110,32 +111,26 @@ public class BlockLogicPistonMoving extends BlockLogic {
         @NotNull World world, @NotNull TilePosc tilePos,
         @NotNull AABBdc aabb, @NotNull List<@NotNull AABBdc> aabbList
     ) {
-        aabbList.add(this.getCollisionAABB(world, tilePos));
-
         if (!(world.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock moving)) return;
 
+        for (final var collision : moving.collisions) {
+            super.addIntersectingBoundingBox(aabb, collision, aabbList);
+        }
+        
         final boolean isRetractingPiston = !moving.isExtending && moving.isSourcePiston;
         if (!isRetractingPiston || !(moving.movingBlock.getLogic() instanceof BlockLogicPistonBase base)) return;
 
-        final var thickness = HEAD_BLOCK_MAP[base.typeId].getLogic().headThickness;        
-        aabbList.add(getBaseCollision(moving.direction, thickness).translate(tilePos.x(), tilePos.y(), tilePos.z()));
-        return;
-    }
-
-    @Override
-    public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
-        if (!(source.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock moving)) {
-            return null;
-        }
-        return moving.collision;
+        final var thickness = HEAD_BLOCK_MAP[base.typeId].getLogic().headThickness;
+        final var baseCollision = getBaseCollision(moving.direction, thickness).translate(tilePos.x(), tilePos.y(), tilePos.z());
+        super.addIntersectingBoundingBox(aabb, baseCollision, aabbList);
+        super.addIntersectingBoundingBox(aabb, new AABBd(0,0,0, 1,1,1).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
     }
 
     @Override
     public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
-        if (source.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock piston) {
-            return piston.bounds;
-        }
-        return super.getBoundsFromState(source, tilePos);
+        return (source.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock piston)
+            ? piston.bounds
+            : super.getBoundsFromState(source, tilePos);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/MovingLine.java b/game/core/src/main/java/net/minecraft/core/block/piston/MovingLine.java
index 53312fb3c..fdb808614 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/MovingLine.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/MovingLine.java
@@ -94,21 +94,43 @@ public final class MovingLine {
         }
     }
 
-    long computeConductMask() {
-        final var queryPos = new TilePos();
-        long set;
+    void init(@NotNull TilePos query) {
+        query.set(this.origin);
+        for (int i = 0;  i < this.len;  i++, query.add(this.direction)) {
+            this.blocks[i] = world.getBlockType(query);
+            this.data[i] = (byte)world.getBlockData(query);
+            this.entities[i] = world.getTileEntity(query);
+
+            assert this.blocks[i] != Blocks.PISTON_MOVING;
+            assert !(this.entities[i] instanceof TileEntityMovingPistonBlock);
+        }
+    }
 
-        set = 0b1L;
-        queryPos.set(this.origin);
-        for (int i = 0;  i < this.len;  i++, set <<= 1, queryPos.add(this.direction)) {
-            if (!world.isBlockNormalCube(queryPos)) continue;
-            if (this.blocks[i] == Blocks.BLOCK_REDSTONE) continue;
-            if (this.blocks[i] == Blocks.PUMPKIN_REDSTONE) continue;
-            if (this.blocks[i] == Blocks.MATCHER_ACTIVE) continue;
-            this.conductMask |= set;
+    void move(@NotNull TilePos query) {
+        query.set(this.origin);
+        for (int i = 0; i < len; i++, query.add(this.direction)) {
+            world.removeTileEntity(query);
+            world.setBlockTypeRaw(query, Blocks.AIR);
+            world.markBlockDirty(query);
         }
+        if (this.isExtending) world.markBlockDirty(query.add(this.direction));
 
-        return this.conductMask;
+        query.set(this.origin).add(this.movingDirection());
+        if (!this.isExtending) world.markBlockDirty(query);
+
+        for (int i = 0; i < len; i++, query.add(this.direction)) {
+            world.setBlockTypeDataEntity(query, Blocks.PISTON_MOVING, this.data[i], this.createMoving(i));
+        }
+    }
+
+    void notify(@NotNull TilePos query1, @NotNull TilePos query2) {
+        final var src = query1.set(this.origin);
+        final var tar = query2.set(this.origin).sub(this.direction);
+
+        for (int i = 0;  i < len;  src.add(this.direction), tar.add(this.direction)) {
+            this.blocks[i].onMoved(world, src, tar, this.movingBlocks[i], i, this);
+            i++;
+        }
     }
 
     // TODO: this can be far more efficient, but the pumpkin edgecase sucks
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/PistonCommon.java b/game/core/src/main/java/net/minecraft/core/block/piston/PistonCommon.java
index 7c628eb80..51bd8ecf2 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/PistonCommon.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/PistonCommon.java
@@ -47,7 +47,8 @@ public abstract class PistonCommon {
 
     /**
      * Event data encodes line length.
-     * @see BlockLogicPistonBase#testLine(World, TilePosc, int)
+     * @see BlockLogicPistonBase#testPushLine(World, TilePosc, int)
+     * @see BlockLogicPistonBase#testPullLine(World, TilePosc, int)
      */ 
     public static final byte EVENT_EXTEND         = 0b00_0; 
     public static final byte EVENT_RETRACT        = 0b00_1;
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
index 63b7c6496..0dfc65837 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
@@ -45,6 +45,18 @@ public class TileEntityMovingPistonBlock extends TileEntity implements IMovingBl
     final @NotNull AABBd sweptCollision = new AABBd();
     final @NotNull Vector3d directionScaled = new Vector3d();
 
+    static final @NotNull Vector3d[] SCALED_DIR_MAP = new Vector3d[6];
+    static {
+        for (final var dir : Direction.all) {
+            SCALED_DIR_MAP[dir.id] = dir.getOffsetScaled(new Vector3d(), PROGRESS_DELTA);
+        }
+    }
+
+    @NotNull AABBd @NotNull[] collisions; {
+        interface ctx { static AABBd[] EMPTY = {}; }
+        collisions = ctx.EMPTY;
+    }
+
     // awkward
     // TODO provide an actual initiallization event that is guaranteed to be called after
     // TODO   tile entity is valid (i.e. not .validate())
@@ -81,8 +93,6 @@ public class TileEntityMovingPistonBlock extends TileEntity implements IMovingBl
         this.direction = direction;
         this.isExtending = type.isExtending;
         this.isSourcePiston = type.isSourcePiston;
-
-        this.movingDirection().getOffsetScaled(this.directionScaled, PROGRESS_DELTA);
     }
 
     @Override
@@ -99,18 +109,25 @@ public class TileEntityMovingPistonBlock extends TileEntity implements IMovingBl
         assert this.worldObj != null;
         assert this.worldObj.isChunkLoaded(new ChunkPos(this.tilePos));
 
-        final var dir = this.movingDirection();
+        interface ctx {
+            Vector3d offset = new Vector3d();
+            ArrayList<AABBdc> collisions = new ArrayList<>(2);
+            AABBdc hugeBB = new AABBd(new Vector3d(Double.NEGATIVE_INFINITY), new Vector3d(Double.POSITIVE_INFINITY));
+        }
 
-        final var off = dir.opposite().getOffset(new Vector3d());
-        this.bounds
-            .set(this.movingBlock.getBoundsFromState(this.worldObj, this.tilePos))
-            .translate(off);
+        this.movingDirection().opposite().getOffset(ctx.offset);
+        this.bounds.set(this.movingBlock.getBoundsFromState(this.worldObj, this.tilePos)).translate(ctx.offset);
 
-        var collision = this.movingBlock.getCollisionAABB(this.worldObj, this.tilePos);
-        if (collision == null) collision = new AABBd(0,0,0,0,0,0);
-        this.collision
-            .set(collision)
-            .translate(off);
+        final var collision = this.movingBlock.getCollisionAABB(this.worldObj, this.tilePos);
+        if (collision != null) this.collision.set(collision).translate(ctx.offset);
+        else this.collision.set(this.bounds).translate(this.tilePos.x(), this.tilePos.y(), this.tilePos.z());
+
+        this.movingBlock.getCollisionAABBs(worldObj, this.tilePos, ctx.hugeBB, ctx.collisions);
+        this.collisions = new AABBd[ctx.collisions.size()];
+        for (int i = 0; i < ctx.collisions.size(); i++) {
+            this.collisions[i] = ctx.collisions.get(i).translate(ctx.offset, new AABBd());
+        }
+        ctx.collisions.clear();
 
         this.isCollisionInited = true;
     }
@@ -123,19 +140,21 @@ public class TileEntityMovingPistonBlock extends TileEntity implements IMovingBl
         if (this.lifetime ++ >= TICKS_TO_EXTEND) {
             this.finalTick();
         } else {
+            final var dir = SCALED_DIR_MAP[this.movingDirection().id];
             this.sweptCollision.set(this.collision);
-            this.sweptCollision.translate(this.directionScaled);
+            this.sweptCollision.translate(dir);
             this.sweptCollision.union(this.collision);
 
             final var entities = this.worldObj.getEntitiesWithinAABBExcludingEntity(null, this.sweptCollision);
             for (final var e : entities) {
                 if (e.noPhysics) continue;
-                e.move(this.directionScaled.x, this.directionScaled.y, this.directionScaled.z);
+                e.move(dir.x, dir.y, dir.z);
             }
 
             // translate block collision after entities are moved
-            this.collision.translate(this.directionScaled);
-            this.bounds.translate(this.directionScaled);
+            this.bounds.translate(dir);
+            this.collision.translate(dir);
+            for (final var collision : this.collisions) collision.translate(dir);
         }
     }
 
@@ -184,10 +203,6 @@ public class TileEntityMovingPistonBlock extends TileEntity implements IMovingBl
 
         this.movingBlock.onMoveComplete(worldObj, selfPos);
 
-        // Block.disableNormalEntityLogic = true;
-        // this.movingBlock.onPlacedByWorld(this.worldObj, selfPos);
-        // Block.disableNormalEntityLogic = false;
-
         assert this.movingTileEntity == null || this.worldObj.getTileEntity(selfPos) == this.movingTileEntity 
             : "Piston failed to actually move entity!";
 
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java b/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
index 1ec5676fe..1a2e889c2 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
@@ -122,7 +122,7 @@ public class Registries extends Registry<Registry<?>> {
             fencesStackList.add(Blocks.FENCE_PLANKS_OAK.getDefaultStack());
             fenceGatesStackList.add(Blocks.FENCE_GATE_PLANKS_OAK.getDefaultStack());
             trapdoorStackList.add(Blocks.TRAPDOOR_PLANKS_OAK.getDefaultStack());
-            woodenButtonsList.add(Blocks.BUTTON_PLANKS.getDefaultStack());
+            woodenButtonsList.add(Blocks.BUTTON_PLANKS_OAK.getDefaultStack());
             woodenPressurePlatesList.add(Blocks.PRESSURE_PLATE_PLANKS_OAK.getDefaultStack());
             buttonsList.add(Blocks.BUTTON_STONE.getDefaultStack());
             buttonsList.add(Blocks.BUTTON_BASALT.getDefaultStack());
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
index c62b4cf45..515df1f98 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
@@ -39,7 +39,7 @@ public class MobGhast extends MobFlying implements Enemy {
         setSize(4F, 4.5F);
         this.fireImmune = true;
         this.scoreValue = 1000;
-        this.mobDrops.add(new WeightedRandomLootObject(Items.GUNPOWDER.getDefaultStack(), 0, 2));
+        this.mobDrops.add(new WeightedRandomLootObject(Items.GUNPOWDER.getDefaultStack(), 3, 8));
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index 597d3a3df..00c23627a 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -1152,6 +1152,7 @@ public abstract class Player
             hurt(null, 4, DamageType.FIRE);
             this.remainingFireTicks = (int) (80 + 520 * protection);
             this.maxFireTicks = this.remainingFireTicks;
+            this.activeFireBlock = Blocks.FIRE;
         }
     }
 
@@ -1162,6 +1163,7 @@ public abstract class Player
             hurt(null, 1, DamageType.FIRE);
             this.remainingFireTicks = (int) (40 + 260 * protection);
             this.maxFireTicks = this.remainingFireTicks;
+            this.activeFireBlock = Blocks.FIRE;
         }
     }
 
